
#include "Bst.h"
#include "Item.h"
#include "huang.h"
#include "math.h"

bool includeWord = false;

ECString indent(int dep) {
  ECString s;
  for (int i=0 ; i < dep; i++)
	s += "|  ";
  return s;
}

void
Bst::
tester(Val* oval)
{
  return;
  Bsts::const_iterator bi = oval->bsts().begin();
  //cerr << "OBS " << oval->bsts().size() << endl;
  int jj = 0;
  for( ; bi != oval->bsts().end() ; bi++)
    {
      cerr << "JJ" << jj << endl;
      jj++;
    }
  cerr << "AFT" << endl;
}
  
bool
Bst::
ptst(Val* val)
{
  int sz = heap.size();
  for(int i = 0 ; i < sz ; i++)
    if(*val==*heap.index(i))
      {
		cerr << "Bad val " << *val << endl;
		return false;
      }
  return true;
}  
  
// lhuang: k-best: next-best
Val*
Bst::
next(int n)
{
  //int hsz = heap.size();
  //cerr << "Need " << n << "th variation out of " << num()
  // << " with " << hsz << " on heap. " << done_<< endl;
  // lhuang: num is how many you have now
  assert(n <= num());
  // lhuang: yes!
  if(num() > n) return nbest[n];
  if(done_) return NULL;
  double oprob = 1;
  if(n > 0)
    {
      assert(nbest[n-1]);
      oprob = nbest[n-1]->prob();
    }
  Val* val = nbest[n-1];
  //cerr << "   For " << *val << endl;
  
  // lhuang: this one should be lazy-next: val->len() is the arity of this hyperedge
  for(int i = 0 ; i < val->len() ; i++)
    {
      bool stop = false;
	  // lhuang: lazy-next
      Val* nv = Val::newIth(i, val,stop);
      if(nv)
		{
		  //cerr << "Got the possible variation " 
		  //   << *nv  << " "<< heap.size()<< " "
		  //   << i << " " << n << " " << num() << endl;
		  //assert(ptst(nv));
		  heap.push(nv);
		}
      if(stop) break;
    }
  if(heap.size()==0)
    {
      done_ = true;
      return NULL;
    }
  // lhuang: the best in cand
  Val* ans = heap.pop();
  // lhuang: ...
  nbest.push_back(ans);
  num_++;
  return ans;
}

int vlens = 100;
Bst::
~Bst()
{
  int i;
  assert(nbest.size() == num());
  for(i = 0 ; i < num() ; i++)
    {
      Val* v = nbest[i];
      delete v;
    }
}
 
Val::
~Val(){}

short
Val::
trm() const
{
  if(status == EXTRAVAL)
    {
      if(len() != 1) return trm_;
      else return bsts_.front()->nth(0)->trm();
    }
  else return trm_;
}

int
Val::
wrd() const
{
  if(status == EXTRAVAL)
    {
      if(len() != 1) return wrd_;
      return bsts_.front()->nth(0)->wrd();
    }
  return wrd_;
}

Val::
Val(Edge* e, double prb)
  :
  status(NORMALVAL),
  len_(0),
  prob_(prb),
  edge_(e),
  wrd_(-2),
  visited (false)
{
  trm_ = e->lhs()->toInt();
  assert(trm_ >= 0 && trm_ < 400);
}

// ? debinarize?
void  
Val::
extendTrees(Bst& bst2,int pos)
{
  len_++;
  vec_.push_back(0);
  if(bsts_.size() == 0) bsts_.push_back(&bst2);
  else if(pos < 2) bsts_.push_front(&bst2);
  else bsts_.push_back(&bst2);
  prob_ *= bst2.prob();
}

// lhuang: the ith tail node of a hyperedge: weird, why not within Val?
Bst&
ithBst(int i, Bsts& bsts)
{
  Bsts::iterator bi = bsts.begin();
  for(int j = 0 ; j < i ; j++) bi++;
  return (**bi);
}

bool
operator==(Val& v1, Val& v2)
{
  if(v1.edge() != v2.edge()) return false;
  shortIter si2 = v2.vec().begin();
  for(shortIter si = v1.vec().begin(); si != v1.vec().end() ; si++)
    {
      if((*si) != (*si2)) return false;
      si2++;
    }
  return true;
}

ostream&
operator<<(ostream& os, const Val& v)
{
  os << "<";
  if(v.edge()) os << *(v.edge());
  else os << v.trm() << " " << v.wrd();
  os << ", ";
  v.vec();
  int sz = v.vec().size();
  for(int i = 0 ; i < sz ; i++)
    {
      os << v.vec()[i];
      if(i < sz-1) os << ",";
    }
  os << ">";
  return os;
}
 
// lhuang: lazynext along this hyperedge, using the next-best of the ith node (directly from my paper :))
Val*
Val::
newIth(int ith, Val* oval, bool& stop)
{
  // vecj[i]
  int ithc = oval->vec(ith);
  if(ithc > 0) stop = true;
  short nxtI = ithc +1;;
  //cerr<< "Wnt " << nxtI << "th var on pos " << ith << " of " << *oval<< endl;
  if(oval->status == TERMINALVAL) return NULL;
  // lhuang: mutual recursion; ithBst is the ith node of the hyperedge, not ith best
  Val* nval = ithBst(ith,oval->bsts()).next(nxtI);
  if(!nval) return NULL;
  double ovalcompprob = ithBst(ith, oval->bsts()).nth(ithc)->prob();
  double nprob = nval->prob();
  //cerr << "Its prob is " << nprob << endl;
  if(nprob < 0) return NULL;
  Val* ans = new Val(oval);
  ans->vec(ith) = nxtI;
  // lhuang: next 2 lines: replacing the old prob w/ the new; 
  double frac = nprob/ovalcompprob;
  ans->prob() *= frac;
  assert(nxtI <= ithBst(ith,ans->bsts()).num());
  //cerr << "ith is " << ith << " " << ans->vec().size() << " "
  //   << ans->vec()[ith] << " " << frac << endl;
  //cerr << "The var is " << *ans << endl;
  //assert(ans->check());
  return ans;
}

Val::
Val(Val* oval)
  :
  status(oval->status),
  len_(oval->len()),
  prob_(oval->prob()),
  edge_(oval->edge()),
  trm_(oval->trm()),
  wrd_(oval->wrd()),
  visited(false)
{
  assert(trm_ >= -1 && trm_ < 400);
  vector<short>::const_iterator vsi = oval->vec().begin();
  for( ; vsi != oval->vec().end() ; vsi++) vec_.push_back(*vsi);
  Bsts::const_iterator bi = oval->bsts().begin();
  for( ; bi != oval->bsts().end() ; bi++)
    {
      bsts_.push_back(*bi);
    }
};
  

bool
Val::
check()
{
  vector<short>::const_iterator vsi = vec().begin();
  Bsts::const_iterator bi = bsts().begin();
  for( ; bi != bsts().end() ; bi++)
    {
      if((*bi)->num() < (*vsi)) return false;
      vsi++;
    }
  
  return true;
}

Bst&
bstFind(CntxArray& ca, BstMap& bm)
{
  BstMap::iterator bi = bm.find(ca);
  if(bi == bm.end())
    {
      return bm[ca];
    }
  
  else return (*bi).second;
}

void
Bst::
push(Val *val) { 
	assert(val);
	heap.push(val); 
 	if (num_ == 0) {
	  // still parsing phase (before n-best) 
	  BS.push_back(val);
 	  if (BS.size() == 1) {
 		// first hyperedge
		// 		label = val->nodeLabel();
 	  }
   }
}

bool
Val::isTerminal() {
  const Term* t = Term::fromInt(trm());
  return (t && t->terminal_p() && status == TERMINALVAL);  
}

ECString
Val::nodeLabel(SentRep & sr, int & pos) {
  ECString s;
  s += Term::fromInt(trm())->name();
  if (isSpurious()) {
	s += "*";
  }
  if (isTerminal()) {
	if (includeWord)
	  s += " \"" + sr[pos].lexeme() + "\"";
	pos++;
  }
  return s;
}

// return something like "NP [2-3]"
ECString
Bst::
labelSpan(bool includeId) {	
  ostringstream os;
  os << label << " [" << start << "-" << end << "]";
  if (includeId)
	os << "(#" << id <<")" ;
  return os.str();
}

// " -> NP [2-3] VP[3-4]
ECString
Val::
RHS() {
  ECString s = "\t->";
  for(Bsts::iterator bi = bsts().begin(); bi != bsts().end(); bi++) {
	s += " " + (*bi) -> labelSpan();	
  }
  return s;
  
}

// lhuang: main work
void printForest(ofstream & fout, Bst & bst, SentRep & sr) {
  Cellstype cells;   // [i,j]
  set<Bst *> visited;
  int n = sr.length();

  //  cerr<<"to print forest"<<endl;
  int start = 0, startid = 0;

  // prepare all nodes
  bst.prepareNode(visited, sr, start, cells, startid, 0);

  fout<<startid<<endl;
  for (int l = 1; l <= n; l ++) {
	for (int i = 0; i <= n-l; i++) {
	  int j = i + l;
	  if (cells[i][j].size()) {
		for (int k = 0; k < cells[i][j].size(); k ++) {
		  Bst * node = cells[i][j][k];
		  vector <Val *> BS = node->BS;

 		  fout << node->id << "\t"<< node->labelSpan(false) << "\t" \
 			   << (node->isTerminal() ? 0 : BS.size()) << endl;

		  int h;
		  for ( h = 0; h < BS.size(); h ++) {
			Val * val = BS[h];
			if (!val->isTerminal()) {
			  fout <<"\t";
			  for (Bsts::iterator bi = val->bsts().begin(); bi != val->bsts().end() ; bi++) {
				fout << (*bi) -> id<< " ";
			  }
			  fout<< " ||| 0=" << val->logprob;
			  fout << endl;
			}
		  }
		}
	  }
	}
  }
  //  cerr <<"--------------------------------------"<<endl;  
}

// lhuang: print forest before n-best, so that the initial ValHeap
// contains the hyperedges, or, <e, \vecone> for all e
// see (Huang and Chiang, 2005) for this notation.
void 
Bst::
prepareNode(set<Bst*> & visited, SentRep& sr, int & pos, \
			Cellstype & cells, int & count, int dep) {

  // if not in visited (insertion succeeded)
  if (visited.insert(this).second) {
	int begn = pos;
	label = BS[0]->nodeLabel(sr, pos);
	int oldpos = pos;

	logprob = log2(prob());
	for (int i = 0; i < BS.size(); i++) { 
	  Val *val = BS[i];	  
	  pos = oldpos;
	  double delta = log2(val->prob());  // note: val->prob() != this->prob() in general!
	  for (Bsts::iterator bi = val->bsts().begin(); bi != val->bsts().end() ; bi++) {
		(*bi)->prepareNode(visited, sr, pos, cells, count, dep+1);		
		delta -= (*bi)->logprob;
	  }
	  val->logprob = delta;
	}
	start = begn;
	end = pos;
	cells[start][end].push_back(this);
	count += 1;
	id = count;
  }
  else {
	// important!!!
	pos = end;
  }
}

